<?
define( "MO_NOTRIM", 1 );
define( "MO_ALLOWHTML", 2 );

function dump($var,$ShowFunc=TRUE,$step=0, $inAryObj=0,$name=''){
	$LEER='                                  ';
	$Out='';
	if (is_array($var)){
		if($inAryObj!=0)$Out.=substr($LEER,0,$step);
		$Out.="=> Array [\n";
		$step+=3; $cc=0;
		foreach($var as $k=>$v){
			if(!$k)$k=$cc++; // if(!$k)continue;
			$Out.=substr($LEER,0,$step). "<b>$k</b> ";
			$Out.=trim(dump($v, $ShowFunc, $step,-1,$k))."\n";
		}
		$step-=3;
		$Out.=substr($LEER,0,$step). " ] <i>End Array : $name</i>\n";
	}else if(is_object($var)){
		if($inAryObj!=0)$Out.=substr($LEER,0,$step);
		$Out.="=> Object '".get_class($var)."' (\n";
		$step+=3;$cc=0;
		foreach(get_object_vars($var) as $k=>$v){
			if(!$k)$k=$cc++; // if(!$k)continue;
			$Out.=substr($LEER,0,$step). "<b>".htmlspecialchars($k)."</b> ";
			$Out.=htmlspecialchars(trim(dump($v, $ShowFunc,$step,1,$k))."\n");
		}
		if($ShowFunc){
			foreach(get_class_methods($var) as $k=>$v){
				if (substr($v,0,2)=='__') continue; // System Funktion
				$Out.=substr($LEER,0,$step). "Funktion : <b>$v()</b>\n";
			}
		}
		$step-=3;
		$Out.=substr($LEER,0,$step). ") <i>End Object : $name</i>\n";
	}else {
		if(is_float($var)) $Out.="(float) => $var\n";
		elseif(is_integer($var)) $Out.="(int) => $var\n";
		elseif(is_bool($var)) $Out.="(bool) => $var\n";
		elseif(is_string($var)) $Out.="(string) => ".htmlspecialchars($var)."\n";
		elseif(is_null($var)) $Out.="=> $var (null)\n";
		else $Out.="=> $var (?)\n";
	}
	return $Out;
}
function dumpvar($var,$VarName='',$ShowFunc=TRUE){
	if($VarName)$VarName=" = $VarName";
	echo "--=> DUMPVAR$VarName <=----------------------------<br>";
	echo nl2br(str_replace(' ','&nbsp;', dump($var,$ShowFunc))); 
}
function CleanTextArray($text){
	$l=explode("\n",str_ireplace('&nbsp;',' ',strip_tags($text)));
	$ll=array();foreach($l as $v){$v=trim($v);if($v)$ll[]=$v;}
	return $ll;
}
function CreateIdentByName($name) {
	$ident = str_replace(' ', '', $name);
	$ident = str_replace(array('�','�','�','�','�','�'), array('oe', 'ae','ue','Oe', 'Ae','Ue' ), $ident);
	$ident = str_replace(array('"','\'','%','&','(',')','=','#','<','>','|','\\'), '', $ident);
	$ident = str_replace(array(',','.',':',';','!','?'), '', $ident);
	$ident = str_replace(array('+','-','/','*'), '', $ident);
	$ident = str_replace(array('�'), 'ss', $ident);
	return $ident;
}
function CombineObject(&$source, &$target) {
	$ok=FALSE;
	foreach (get_object_vars( $source ) as $k => $v) {
		if (is_array($v) or is_object($v) or $v == NULL) {
			continue;
		}
		if ($k[0] == '_') { // internal field
		  continue;
		}
		if ($v == PASSWORD_VALUE) { // Password blank nicht spaichern
		  continue;
		}
		if(isSet($target->{$k})){
	
			$target->{$k}=$source->{$k};
			$ok=TRUE;
		}
	}
	return $ok;
}
function formatText($text, $maxlen=50){
//  if(!$text || strlen($text)<$maxlen)return $text;
  $a=preg_split("/[\n]+/",$text); $l=''; $ln="\n"; //chr(13).chr(10);
  for($i=0;$i<count($a);$i++){
    $s=wordwrap($a[$i],$maxlen,"\n");
    $b=preg_split("/[\n]+/",$s);
    $l.=($l)?$ln."- $b[0]":"- $b[0]";
    for($ii=1;$ii<count($b);$ii++){
      $l.=$ln."  $b[$ii]";
    }
  }
  return $l;
}

function Request($name, $def=null, $mask=0 ) {
    global $_REQUEST, $_POST;
    if($_REQUEST)$_R=&$_REQUEST; else $_R=&$_POST;
    if (isset( $_R[$name] )) {
      $result=$_R[$name];
      if (is_string( $result)) {
            if (!($mask&MO_NOTRIM)) {
                $result = trim( $result );
            }
            if (!($mask&MO_ALLOWHTML)) {
                $result = strip_tags( $result );
            }
            if (!get_magic_quotes_gpc()) {
                $result = addslashes( $result );
            }
      }
      return $result;
    } else {
        return $def;
    }
}

function RequestObject($include, $AllowNull=true, $OnlyIfSet=true, $prefix=''){
  if(!$include)return null;
  if(!is_array($include))$include=array($include);
  $o=new stdClass();
  foreach($include as $n){
    $v=Request($prefix.$n,'-xb!+@');
    if ($v=='-xb!+@'){
      if ($OnlyIfSet)continue;
      $v='';
    }
    if(($AllowNull)||($v))$o->$n=$v;
  }
  return $o;
}

function Redirect( $url, $msg='', $timeout=0, $asScript=false ) {
    if(!(stripos($url,'javascript:')===false)){
      $data="<script>\n".substr($url,11).";</script>";
      die("$data");
    }else
      if (trim( $msg ))$url.=(strstr( $url, '?' ))? "&msg=$msg" : "?msg=$msg";
      if (headers_sent()) {
       if($timeout)
         $data="<script>;
         function refreshurl(){
           document.location.href='$url';
         }
         setTimeout(function(){ refreshurl(); }, ".($timeout*1000).");
         </script>";
       else
         $data="<script>document.location.href='$url';</script>\n";
    } else {
       if($timeout)
          header ("Refresh: $timeout url=$url");
       else
          header( "Location: $url" );
    }
    if ($asScript)return $data;
    echo $data;
    exit();
}

function unzip($file, $path, &$files) {
  $zip = zip_open($file);
  if ($zip) {
   while ($zip_entry = zip_read($zip)) {
     if (zip_entry_filesize($zip_entry) > 0) {
       // str_replace must be used under windows to convert "/" into "\"
       $complete_path = $path.str_replace('/','',dirname(zip_entry_name($zip_entry)));
       $complete_name = $path.str_replace ('/','',zip_entry_name($zip_entry));
       if(!file_exists($complete_path)) { 
         $tmp = '';
         foreach(explode('',$complete_path) AS $k) {
           $tmp .= $k.'';
           if(!file_exists($tmp)) {
             mkdir($tmp, 0777); 
           }
         } 
       }
       if (zip_entry_open($zip, $zip_entry, "r")) {
         $files[]=$complete_name;
         $fd = fopen($complete_name, 'w');
         fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
         fclose($fd);
         zip_entry_close($zip_entry);
       }
     }
   }
   zip_close($zip);
  }
}
?>